resource "aws_cloudwatch_dashboard" "this" {
  dashboard_name = "${var.alias}-${var.environment}"

  dashboard_body = <<EOF
  {
    "widgets":[
        {
          "type":"metric",
          "x":0,
          "y":0,
          "width":24,
          "height":9,
          "properties":{
              "view":"timeSeries",
              "stacked":false,
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "RequestCount",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "period":5,
                      "stat":"Sum"
                    }
                ],
                [
                    ".",
                    "HTTPCode_Target_5XX_Count",
                    ".",
                    ".",
                    {
                      "yAxis":"left",
                      "period":5,
                      "stat":"Sum"
                    }
                ],
                [
                    ".",
                    "HTTPCode_Target_4XX_Count",
                    ".",
                    ".",
                    {
                      "yAxis":"left",
                      "period":5,
                      "stat":"Sum"
                    }
                ],
                [
                    ".",
                    "HTTPCode_Target_3XX_Count",
                    ".",
                    ".",
                    {
                      "yAxis":"left",
                      "period":5,
                      "stat":"Sum"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Requests"
          }
        },
        {
          "type":"metric",
          "x":0,
          "y":9,
          "width":6,
          "height":3,
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ElastiCache",
                    "BytesUsedForCache",
                    "CacheClusterId",
                    "cache-production-001"
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Cache Size",
              "period":300
          }
        },
        {
          "type":"metric",
          "x":12,
          "y":9,
          "width":12,
          "height":6,
          "properties":{
              "view":"timeSeries",
              "metrics":[
                [
                    "AWS/ECS",
                    "CPUUtilization",
                    "ServiceName",
                    "acg-production-http",
                    "ClusterName",
                    "acg-development",
                    {
                      "label":"CPU Utilization",
                      "stat":"Average"
                    }
                ],
                [
                    "...",
                    {
                      "stat":"Maximum",
                      "label":"CPU Utilization Maximum"
                    }
                ],
                [
                    "...",
                    {
                      "stat":"Minimum",
                      "label":"CPU Utilization Minimum"
                    }
                ],
                [
                    ".",
                    "MemoryUtilization",
                    ".",
                    ".",
                    ".",
                    ".",
                    {
                      "label":"Memory Utilization",
                      "yAxis":"right"
                    }
                ],
                [
                    "...",
                    {
                      "stat":"Maximum",
                      "label":"Memory Utilization Maximum",
                      "yAxis":"right"
                    }
                ],
                [
                    "...",
                    {
                      "stat":"Minimum",
                      "label":"MemoryUtilization Minimum",
                      "yAxis":"right"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Container Stats",
              "period":300,
              "stacked":false
          }
        },
        {
          "type":"metric",
          "x":6,
          "y":9,
          "width":6,
          "height":3,
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "HealthyHostCount",
                    "TargetGroup",
                    "targetgroup/acg-production-http/82f711dd4ad12337",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "label":"Healthy",
                      "stat":"Maximum"
                    }
                ],
                [
                    ".",
                    "UnHealthyHostCount",
                    ".",
                    ".",
                    ".",
                    ".",
                    {
                      "label":"UnHealthy",
                      "yAxis":"left",
                      "stat":"Maximum"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Hosts Max (Last 5 mins)",
              "period":300
          }
        },
        {
          "type":"metric",
          "x":0,
          "y":12,
          "width":3,
          "height":3,
          "styles":"undefined",
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "TargetResponseTime",
                    "TargetGroup",
                    "targetgroup/acg-production-http/82f711dd4ad12337",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "stat":"p99",
                      "label":"p99"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "period":300,
              "title":"Time 99%"
          }
        },
        {
          "type":"metric",
          "x":3,
          "y":12,
          "width":3,
          "height":3,
          "styles":"undefined",
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "TargetResponseTime",
                    "TargetGroup",
                    "targetgroup/acg-production-http/82f711dd4ad12337",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "stat":"p95",
                      "label":"p95"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Time 95%",
              "period":300
          }
        },
        {
          "type":"metric",
          "x":6,
          "y":12,
          "width":3,
          "height":3,
          "styles":"undefined",
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "TargetResponseTime",
                    "TargetGroup",
                    "targetgroup/acg-production-http/82f711dd4ad12337",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "stat":"p90",
                      "label":"p90"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Time 90%",
              "period":300
          }
        },
        {
          "type":"metric",
          "x":9,
          "y":12,
          "width":3,
          "height":3,
          "styles":"undefined",
          "properties":{
              "view":"singleValue",
              "metrics":[
                [
                    "AWS/ApplicationELB",
                    "TargetResponseTime",
                    "TargetGroup",
                    "targetgroup/acg-production-http/82f711dd4ad12337",
                    "LoadBalancer",
                    "app/acg-production-http/b52c482b8b48174f",
                    {
                      "stat":"p50",
                      "label":"p50"
                    }
                ]
              ],
              "region":"ap-southeast-2",
              "title":"Time 50%",
              "period":300
          }
        }
    ]
  }
  EOF
}
